#![feature(str_from_utf16_endian)]

mod interceptor;
mod marshal;
mod modules;
mod util;

use std::{sync::Mutex, time::Duration};

use lazy_static::lazy_static;
use modules::{ModuleManager, Sdk};
use windows::Win32::{
    Foundation::HINSTANCE,
    System::{Console, SystemServices::DLL_PROCESS_ATTACH},
};

use crate::modules::{Http, MhyContext, Security};

unsafe fn thread_func() {
    Console::AllocConsole().unwrap();

    println!("Zenless Zone Zero client patch");
    println!("to work with JaneDoe-ZS (https://git.xeondev.com/NewEriduPubSec/JaneDoe-ZS)");
    println!("patch loaded, waiting for game startup...");
    println!("Don't forget to visit https://discord.xeondev.com/");

    let base = loop {
        let Some(base) = util::try_get_base_address("GameAssembly.dll") else {
            std::thread::sleep(Duration::from_millis(500));
            continue;
        };

        break base;
    };

    println!("GameAssembly: {base:X}");

    std::thread::sleep(Duration::from_secs(7)); // wait for game init
    util::disable_memprotect_guard();

    let mut module_manager = MODULE_MANAGER.lock().unwrap();
    module_manager.enable(MhyContext::<Http>::new(base));
    module_manager.enable(MhyContext::<Sdk>::new(base));
    module_manager.enable(MhyContext::<Security>::new(base));

    println!("Initialized!");
}

lazy_static! {
    static ref MODULE_MANAGER: Mutex<ModuleManager> = Mutex::new(ModuleManager::default());
}

#[no_mangle]
unsafe extern "system" fn DllMain(_: HINSTANCE, call_reason: u32, _: *mut ()) -> bool {
    if call_reason == DLL_PROCESS_ATTACH {
        std::thread::spawn(|| thread_func());
    }

    true
}
